#!/usr/bin/python

# RevKit: A Toolkit for Reversible Circuit Design (www.revkit.org)
# Copyright (C) 2009-2010  The RevKit Developers <revkit@informatik.uni-bremen.de>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

import sys
from revkit import *

opts = program_options()
opts.add_option( "filename", "PLA filename containing an irreversible function specification" ) \
    .add_option( "specname", "Filename where to write the embedded specification" ) \
    .add_option( "garbage_name", "g", "Name for the garbage lines added with embedding the specification" )

opts.parse( sys.argv )

if not( opts.good() and opts.is_set( "filename" ) and opts.is_set( "specname" ) ):
    print opts
    exit( 1 )

base = binary_truth_table()
spec = binary_truth_table()

read_specification_from_pla( base, opts["filename"] )

embed_truth_table( spec, base, garbage_name = opts["garbage_name"] )

write_specification( spec, opts["specname"] )
